#pragma once

#include <string>
#include <array>
#include <vector>
#include <memory>
#include <mutex>
#include <boost\optional.hpp>

#include "simstring\simstring.h"


class UmaEventLibrary
{
public:
	struct EventOptionEffect {
		std::wstring	option;	// I
		std::wstring	effect;	// 
	};
	enum { kMaxOption = 3 };	// 1̃CxgɕtAő3̑I
	typedef std::array<EventOptionEffect, kMaxOption>	EventOptions;

	struct UmaEvent {
		std::wstring	eventName;		// Cxg
		EventOptions	eventOptions;
	};

	// l̃LLSCxg
	struct CharaEvent {
		std::wstring	name;	// L / T|[g
		std::wstring	property;	// [1, 2, 3] / [SSR, SR, R]
		std::vector<UmaEvent>	umaEventList;	// LLSCxgXg
	};
	typedef std::vector<std::unique_ptr<CharaEvent>>	CharaEventList;

	// UmaMusumeLibrary.json ǂݍ
	bool	LoadUmaMusumeLibrary();

	// ݑI𒆂̈琬E}Ԃ
	const std::wstring& GetCurrentIkuseiUmaMusume() const {
		return m_currentIkuseUmaMusume;
	}

	// 琬E}̃CxgXgԂ
	const CharaEventList& GetIkuseiUmaMusumeEventList() const {
		return m_charaEventList;
	}

	// ΏۂƂ琬E}ύX
	void	ChangeIkuseiUmaMusume(const std::wstring& umaName);

	// ܂ň琬E}ύX
	void	AnbigiousChangeIkuseImaMusume(std::vector<std::wstring> ambiguousUmaMusumeNames);

	// ܂ŃCxgT
	boost::optional<UmaEvent>	AmbiguousSearchEvent(
		const std::vector<std::wstring>& ambiguousEventNames,
		const std::vector<std::wstring>& ambiguousEventBottomOptions );

	// Cxgǂ̃L甭̂Ԃ
	const std::wstring& GetLastEventSource() const {
		return m_lastEventSource;
	}

private:
	void		_DBUmaNameInit();
	void		_DBInit();
	UmaEvent	_SearchEventOptions(const std::wstring& eventName);
	UmaEvent	_SearchEventOptionsFromBottomOption(const std::wstring& bottomOption);

	// ݑI𒆂̈琬E}̖O
	std::wstring	m_currentIkuseUmaMusume;
	std::mutex		m_mtxName;

	// 琬E}
	CharaEventList	m_charaEventList;
	// T|[gJ[h
	CharaEventList	m_supportEventList;

	std::wstring	m_lastEventSource;

	bool	m_simstringDBInit = false;
	std::unique_ptr<simstring::reader>	m_dbUmaNameReader;
	std::unique_ptr<simstring::reader>	m_dbReader;
	std::unique_ptr<simstring::reader>	m_dbOptionReader;

	double	m_kMinThreshold = 0.4;
};

